#include <QApplication>
#include <QQuickWidget>
#include <QOpenGLContext>

int main(int argc, char *argv[])
{
    // Set default format to 3.2 Core.
    QSurfaceFormat format;
    format.setVersion(3, 2);
    format.setProfile(QSurfaceFormat::CoreProfile);
    QSurfaceFormat::setDefaultFormat(format);

    // Enable sharing.
    QApplication::setAttribute(Qt::AA_ShareOpenGLContexts);
    QApplication a(argc, argv);

    QQuickWidget w;

    QOpenGLContext *globalSharedContext = QOpenGLContext::globalShareContext();
    QSurfaceFormat defaultFormat = QSurfaceFormat::defaultFormat();

    // Works, contains the version 3.2 Core, which ends up being created as a 4.1 version,
    // upon creation of the native OpenGL context.
    //w.setFormat(defaultFormat);

    // Doesn't work, contains the version 4.1 Core which was set upon creation of the global
    // context.
    w.setFormat(globalSharedContext->format());
    w.show();

    return a.exec();
}
